' *************************************************************************
' **                                                                     **
' **                            3DK2POV v1.2                             **
' **                                                                     **
' **   Por Diego Berrueta Muoz                        Septiembre 1994   **
' **                                                                     **
' **   Una utilidad para generar escenas en POV-Ray a partir de modelos  **
' **                creados con el 3D-Construction Kit.                  **
' **                                                                     **
' *************************************************************************


DECLARE SUB ch (salida%)
DECLARE SUB cpn (salida%)
DECLARE SUB ct (salida%)
DECLARE SUB cc (salida%)
DECLARE SUB cb (salida%)
DECLARE SUB fc (salida%)
DECLARE SUB camara (ee%, salida%, as$)
DECLARE FUNCTION vector$ (v1%, v2%, v3%)
DECLARE FUNCTION bm% (c$, cab$)
DECLARE FUNCTION bi% (c$, cab$)
DECLARE FUNCTION lee$ (entrada%)
DECLARE FUNCTION esfi$ ()
DECLARE FUNCTION esar% (na%)
DECLARE FUNCTION esen% (nde%)

OPTION BASE 1

' Define el array VectoresBox
DIM SHARED vb(2, 3) AS INTEGER
' Define al array VectoresTringulo
DIM SHARED vt(3, 3) AS INTEGER
' Define el array VectoresCuadriltero
DIM SHARED vc(4, 3) AS INTEGER
' Define el array Vectores Pentgono
DIM SHARED vpn(5, 3) AS INTEGER
' Define el array VectoresHexgono
DIM SHARED vh(6, 3) AS INTEGER
' Dimensiona el array que almacenar las descripciones de las entradas
DIM SHARED de(40) AS STRING

' La pantalla de presentacin
SCREEN 0, 0, 0, 0
GOSUB pantallabienvenida:
CLS

ON ERROR GOTO errores:

' La subrutina para escoger el archivo
ae$ = UCASE$(esfi$)
CLS

as$ = LEFT$(ae$, LEN(ae$) - 4) + ".POV"

' Abre el archivo de salida
salida% = 1
OPEN as$ FOR OUTPUT AS #salida%

' Abre el archivo de entrada
entrada% = 3
OPEN ae$ FOR INPUT AS #entrada%

' Interpretacin de la cabecera
GOSUB fdli:
' Interpretacin de los datos
GOSUB lyi:
CLOSE
PRINT
PRINT "PROCESO FINALIZADO CON XITO"
DO
LOOP WHILE INKEY$ = ""
CLS
END


' **********************************************************************
' **********************************************************************
' **********************************************************************

pantallabienvenida:
SCREEN 0, 0, 0, 0
CLS

COLOR 4, 0: LOCATE 1, 2: PRINT STRING$(78, "")
COLOR 4, 0: LOCATE 10, 2: PRINT STRING$(78, "")

FOR x% = 2 TO 9
  COLOR 1, 0: LOCATE x%, 3: PRINT STRING$(76, "")
  COLOR 4, 0: LOCATE x%, 2: PRINT ""
  COLOR 4, 0: LOCATE x%, 79: PRINT ""
NEXT x%

COLOR 15, 1: LOCATE 3, 34: PRINT "Ŀ"
COLOR 15, 1: LOCATE 4, 34: PRINT "   3DK2POV   "
COLOR 15, 1: LOCATE 5, 34: PRINT "             "
COLOR 15, 1: LOCATE 6, 34: PRINT ""
COLOR 2, 1: LOCATE 5, 36: PRINT "Versin 1.2"
COLOR 7, 1: LOCATE 8, 5: PRINT "Por Diego Berrueta Muoz"
COLOR 7, 1: LOCATE 8, 62: PRINT "Septiembre 1994"
COLOR 8, 0: LOCATE 18, 32: PRINT "Pulse cualquier tecla"
COLOR 7, 0
DO
LOOP WHILE INKEY$ = ""
RETURN




' ************************************************************************
' ************************************************************************
' ************************************************************************
fdli:
' Funciones de Lectura Iniciales

CLS
COLOR 7, 0
PRINT "Espere un momento..."

' Lee el nmero de reas (numareas%)
DO
  l$ = lee$(entrada%)
  IF bi%(l$, "Areas:") THEN
    l$ = lee$(entrada%)
    numareas% = VAL(l$)
    EXIT DO
  END IF
  IF EOF(entrada%) THEN ERROR 100
LOOP

CLOSE #entrada%
' Reinicia el archivo para leer nuevamente desde el principio.
OPEN ae$ FOR INPUT AS #entrada%

' Escoge el rea que debe ser convertida
ae% = esar%(numareas%)

CLS
COLOR 7, 0
PRINT "Espere un momento..."

' Bsqueda del rea especificada (ae%)
DO
  l$ = lee$(entrada%)
  IF bi%(l$, "------ AREA NUMBER") THEN
    IF ae% = VAL(MID$(l$, 21, 4)) THEN EXIT DO
  END IF
  IF EOF(entrada%) THEN ERROR 101
LOOP

' Obtiene el nmero de objetos
l$ = lee$(entrada%)
l$ = lee$(entrada%)
numobjetos% = VAL(MID$(l$, 1, 2))

' Busca las entradas
escr% = 0
DO
  l$ = lee$(entrada%)
  IF bi%(l$, "ENTRANCES") THEN EXIT DO
  IF EOF(entrada%) THEN ERROR 102
LOOP

' Avanza unas lneas
l$ = lee$(entrada%)
l$ = lee$(entrada%)

' Lee el nmero de entradas (ne%) y escribe los datos de las mismas
' en un array (de)
ne% = 0
DO
  l$ = lee$(entrada%)
  l$ = lee$(entrada%)
  IF l$ = "OBJECTS:" THEN EXIT DO
  ne% = ne% + 1
  de(ne%) = l$
  IF EOF(entrada%) THEN ERROR 103
LOOP

' Avanza unas lneas y posiciona el puntero sobre el primer dato
l$ = lee$(entrada%)
l$ = lee$(entrada%)

' Aqu va el men para escoger la entrada
ee% = esen(ne%)
CLS

COLOR 15, 0: LOCATE 3, 3: PRINT "ESTADISTICAS:"
COLOR 15, 0: LOCATE 4, 3: PRINT "============="
COLOR 7, 0: LOCATE 7, 1
PRINT "Archivo de entrada:"; TAB(26); ae$
PRINT "Archivo de salida:"; TAB(26); as$
PRINT "Nmero de reas:"; TAB(25); numareas%
PRINT "Area especificada:"; TAB(25); ae%
PRINT "Objetos en el rea:"; TAB(25); numobjetos%
PRINT "Nmero de entradas:"; TAB(25); ne%
PRINT "Entrada especificada:"; TAB(25); ee%

' Comienza a trabajar
' Primero escribe la cabezera y crea la cmara
CALL camara(ee%, salida%, as$)
RETURN


' ************************************************************************
' ************************************************************************
' ************************************************************************
' ************************************************************************
' ************************************************************************
' ************************************************************************

lyi:
' Lectura e interpretacin de los datos del archivo
numobj% = 0
DO
numobj% = numobj% + 1
  objabus$ = LTRIM$(STR$(numobj%) + ":")
  DO
    l$ = lee$(entrada%)
    IF l$ = "ANIMATORS:" THEN GOTO finarea:
    IF bi%(l$, objabus$) THEN GOTO lecturadeobjeto:
    IF EOF(entrada%) THEN ERROR 104
  LOOP
pasa:
LOOP
finarea:
PRINT #salida%, "}"
PRINT #salida%, "// Coloque aqu las texturas, pigmentos..."
PRINT #salida%, "}"
RETURN

lecturadeobjeto:
nomobj$ = MID$(l$, bm%(l$, ":") + 2, 10)
IF bm%(l$, "Cube") THEN GOTO cubo:
IF bm%(l$, "Rectangle") THEN GOTO paralelogramo:
IF bm%(l$, "Triangle") THEN GOTO triangulo:
IF bm%(l$, "Hexagon") THEN GOTO hexagono:
IF bm%(l$, "Quadrilateral") THEN GOTO cuadrilatero:
GOTO pasa:


cubo:
l$ = lee$(entrada%)
vb(1, 1) = VAL(MID$(l$, 11, 4))
vb(1, 2) = VAL(MID$(l$, 16, 4))
vb(1, 3) = VAL(MID$(l$, 21, 4))
vb(2, 1) = VAL(MID$(l$, 32, 4)) + vb(1, 1)
vb(2, 2) = VAL(MID$(l$, 37, 4)) + vb(1, 2)
vb(2, 3) = VAL(MID$(l$, 42, 4)) + vb(1, 3)
PRINT #salida%, "// "; nomobj$; " - Cubo "; numobj%
CALL cb(salida%)
PRINT #salida%, ""
GOTO pasa:

paralelogramo:
l$ = lee$(entrada%)
vc(1, 1) = VAL(MID$(l$, 11, 4))
vc(1, 2) = VAL(MID$(l$, 16, 4))
vc(1, 3) = VAL(MID$(l$, 21, 4))
vc(3, 1) = VAL(MID$(l$, 32, 4)) + vc(1, 1)
vc(3, 2) = VAL(MID$(l$, 37, 4)) + vc(1, 2)
vc(3, 3) = VAL(MID$(l$, 42, 4)) + vc(1, 3)
IF vc(3, 1) = vc(1, 1) THEN
  vc(2, 1) = vc(1, 1)
  vc(4, 1) = vc(1, 1)
  vc(2, 2) = vc(1, 2)
  vc(2, 3) = vc(3, 3)
  vc(4, 2) = vc(3, 2)
  vc(4, 3) = vc(1, 3)
END IF
IF vc(3, 2) = vc(1, 2) THEN
  vc(2, 2) = vc(1, 2)
  vc(4, 2) = vc(1, 2)
  vc(2, 1) = vc(1, 1)
  vc(2, 3) = vc(3, 3)
  vc(4, 1) = vc(3, 1)
  vc(4, 3) = vc(1, 3)
END IF
IF vc(3, 3) = vc(1, 3) THEN
  vc(2, 3) = vc(1, 3)
  vc(4, 3) = vc(1, 3)
  vc(2, 1) = vc(1, 1)
  vc(2, 2) = vc(3, 2)
  vc(4, 1) = vc(3, 1)
  vc(4, 2) = vc(1, 2)
END IF
PRINT #salida%, "// "; nomobj$; " - Paralelogramo "; numobj%
CALL cc(salida%)
PRINT #salida%, ""
GOTO pasa:

triangulo:
l$ = lee$(entrada%)
p1% = VAL(MID$(l$, 11, 4))
p2% = VAL(MID$(l$, 16, 4))
p3% = VAL(MID$(l$, 21, 4))
l$ = lee$(entrada%)
FOR vertice% = 1 TO 3
  l$ = lee$(entrada%)
  vt(vertice%, 1) = VAL(MID$(l$, 11, 4)) + p1%
  vt(vertice%, 2) = VAL(MID$(l$, 16, 4)) + p2%
  vt(vertice%, 3) = VAL(MID$(l$, 21, 4)) + p3%
NEXT vertice%
PRINT #salida%, "// "; nomobj$; " - Tringulo "; numobj%
CALL ct(salida%)
PRINT #salida%, ""
GOTO pasa:

hexagono:
l$ = lee$(entrada%)
p1% = VAL(MID$(l$, 11, 4))
p2% = VAL(MID$(l$, 16, 4))
p3% = VAL(MID$(l$, 21, 4))
l$ = lee$(entrada%)
FOR vertice% = 1 TO 6
  l$ = lee$(entrada%)
  vh(vertice%, 1) = VAL(MID$(l$, 11, 4)) + p1%
  vh(vertice%, 2) = VAL(MID$(l$, 16, 4)) + p2%
  vh(vertice%, 3) = VAL(MID$(l$, 21, 4)) + p3%
NEXT vertice%
PRINT #salida%, "// "; nomobj$; " - Hexgono "; numobj%
CALL ch(salida%)
PRINT #salida%, ""
GOTO pasa:

cuadrilatero:
l$ = lee$(entrada%)
p1% = VAL(MID$(l$, 11, 4))
p2% = VAL(MID$(l$, 16, 4))
p3% = VAL(MID$(l$, 21, 4))
l$ = lee$(entrada%)
FOR vertice% = 1 TO 4
  l$ = lee$(entrada%)
  vc(vertice%, 1) = VAL(MID$(l$, 11, 4)) + p1%
  vc(vertice%, 2) = VAL(MID$(l$, 16, 4)) + p2%
  vc(vertice%, 3) = VAL(MID$(l$, 21, 4)) + p3%
NEXT vertice%
PRINT #salida%, "// "; nomobj$; " - Cuadriltero "; numobj%
CALL cc(salida%)
PRINT #salida%, ""
GOTO pasa:


errores:
SCREEN 0, 0, 3, 3
CLS
COLOR 7, 0
PRINT "Error:"; ERR
SELECT CASE ERR
  CASE 53
    PRINT "El archivo especificado no existe, imposible continuar."
  CASE 100
    PRINT "La funcin de contar reas excedi el final del archivo."
  CASE 101
    PRINT "La funcin de bsqueda del rea especificada excedi el final del archivo."
  CASE 102
    PRINT "La funcin de bsqueda de entradas excedi el final del archivo."
  CASE 103
    PRINT "La funcin de contar entradas excedi el final del archivo."
  CASE 104
    PRINT "La funcin de examinar datos excedi el final del archivo."
  CASE ELSE
    PRINT "Error inesperado, imposible continuar."
END SELECT
DO
LOOP WHILE INKEY$ = ""
END

RESUME

FUNCTION bi% (c$, cab$)
' Funcin para la bsqueda por la izquierda de una cadena

longitud1 = LEN(cab$)
longitud2 = LEN(c$)
IF longitud1 <= longitud2 THEN
  IF LEFT$(c$, longitud1) = cab$ THEN bi = 1
  IF LEFT$(c$, longitud1) <> cab$ THEN bi = 0
END IF
END FUNCTION

FUNCTION bm% (c$, cab$)
' Funcin de bsqueda de una cadena insertada en otra

longitud1 = LEN(cab$)
longitud2 = LEN(c$)
IF longitud1 <= longitud2 THEN
  bm% = INSTR(c$, cab$)
ELSE
  CLS
  PRINT "Error de lgica en la funcin 'bm'."
  DO
  LOOP WHILE INKEY$ = ""
  END
END IF

END FUNCTION

SUB camara (ee%, salida%, as$)
' Este procedimiento crea la cabecera del fichero y
' coloca la cmara.

v1% = VAL(MID$(de(ee%), 11, 4))
v2% = VAL(MID$(de(ee%), 16, 4))
v3% = VAL(MID$(de(ee%), 21, 4))
PRINT #salida%, "/* ARCHIVO: " + as$
PRINT #salida%, ""
PRINT #salida%, "Creado en 3D Construction Kit y transformado en fichero"
PRINT #salida%, "POV-Ray por la utilidad 3DK2POV. */"
PRINT #salida%, ""
PRINT #salida%, "// Coloque aqu las llamadas a los ficheros include"
PRINT #salida%, ""
PRINT #salida%, "// Esta es la colocacin de la cmara"
PRINT #salida%, "camera{"
PRINT #salida%, "  location " + vector$(v1%, v2%, v3%)
PRINT #salida%, "// Coloque aqu la sentencia look_at"
PRINT #salida%, "}"
PRINT #salida%, ""
PRINT #salida%, "// Coloque aqu las fuentes de luz"
PRINT #salida%, ""
PRINT #salida%, "// Aqu comienza la descripcin de los objetos"
PRINT #salida%, "// NOTA: el objeto se extiende desde <0,0,0> hasta"
PRINT #salida%, "// <8191,8191,8191>, por lo que sera conveniente"
PRINT #salida%, "// modificar su tamao para moverlo ms fcilmente."
PRINT #salida%, "object{union{"
END SUB

SUB cb (salida%)

' Procedimiento ConstruyeBox (cb)
' Qu hace?:
'           definir una caja
' Entrada:
'           el array vb(de 1 hasta 2)
'           la variable salida%
' Salida:
'           en el fichero #salida%

v1$ = vector$(vb(1, 1), vb(1, 2), vb(1, 3))
v2$ = vector$(vb(2, 1), vb(2, 2), vb(2, 3))
PRINT #salida%, "object{box{" + v1$ + "," + v2$ + "}}"

END SUB

SUB cc (salida%)

' Procedimiento ConstruyeCuadriltero (cc)
' Qu hace?:
'           definir un cuadriltero
' Entrada:
'           el array vc(de 1 hasta 4)
'           la variable salida%
' Salida:
'           en el fichero #salida%

PRINT #salida%, "object{union{"

v1$ = vector$(vc(1, 1), vc(1, 2), vc(1, 3))
v2$ = vector$(vc(2, 1), vc(2, 2), vc(2, 3))
v3$ = vector$(vc(3, 1), vc(3, 2), vc(3, 3))
PRINT #salida%, "  triangle{" + v1$ + "," + v2$ + "," + v3$ + "}"
v1$ = vector$(vc(1, 1), vc(1, 2), vc(1, 3))
v2$ = vector$(vc(4, 1), vc(4, 2), vc(4, 3))
v3$ = vector$(vc(3, 1), vc(3, 2), vc(3, 3))
PRINT #salida%, "  triangle{" + v1$ + "," + v2$ + "," + v3$ + "}}}"


END SUB

SUB ch (salida%)

' Procedimiento ConstruyeHexgono (ch)
' Qu hace?:
'           definir una hexgono con 4 tringulos
' Entrada:
'           el array vh(de 1 hasta 6)
'           la variable salida%
' Salida:
'           en el fichero #salida%

v1$ = vector$(vh(1, 1), vh(1, 2), vh(1, 3))
v2$ = vector$(vh(2, 1), vh(2, 2), vh(2, 3))
v3$ = vector$(vh(3, 1), vh(3, 2), vh(3, 3))
v4$ = vector$(vh(4, 1), vh(4, 2), vh(4, 3))
v5$ = vector$(vh(5, 1), vh(5, 2), vh(5, 3))
v6$ = vector$(vh(6, 1), vh(6, 2), vh(6, 3))

PRINT #salida%, "object{union{"
' Primero los dos tringulos
PRINT #salida%, "  triangle{" + v1$ + "," + v5$ + "," + v6$ + "}"
PRINT #salida%, "  triangle{" + v2$ + "," + v3$ + "," + v4$ + "}"
' Ahora el cuadriltero interior
PRINT #salida%, "  triangle{" + v1$ + "," + v5$ + "," + v4$ + "}"
PRINT #salida%, "  triangle{" + v1$ + "," + v2$ + "," + v4$ + "}}}"

END SUB

SUB cpn (salida%)

' Procedimiento ConstruyePentgono (cpn)
' Qu hace?:
'           definir una pentgono con 3 tringulos
' Entrada:
'           el array vpn(de 1 hasta 3)
'           la variable salida%
' Salida:
'           en el fichero #salida%

v1$ = vector$(vpn(1, 1), vpn(1, 2), vpn(1, 3))
v2$ = vector$(vpn(2, 1), vpn(2, 2), vpn(2, 3))
v3$ = vector$(vpn(3, 1), vpn(3, 2), vpn(3, 3))
v4$ = vector$(vpn(4, 1), vpn(4, 2), vpn(4, 3))
v5$ = vector$(vpn(5, 1), vpn(5, 2), vpn(5, 3))

PRINT #salida%, "object{{"
PRINT #salida%, "  triangle{" + v1$ + "," + v2$ + "," + v3$ + "}"
PRINT #salida%, "  triangle{" + v1$ + "," + v3$ + "," + v5$ + "}"
PRINT #salida%, "  triangle{" + v3$ + "," + v4$ + "," + v5$ + "}}}"
END SUB

SUB ct (salida%)

' Procedimiento ConstruyeTringulo (ct)
' Qu hace?:
'           elaborar un tringulo
' Entrada:
'           el array vt(de 1 hasta 3)
'           la variable salida%
' Salida:
'           en el fichero #salida%

v1$ = vector$(vt(1, 1), vt(1, 2), vt(1, 3))
v2$ = vector$(vt(2, 1), vt(2, 2), vt(2, 3))
v3$ = vector$(vt(3, 1), vt(3, 2), vt(3, 3))
PRINT #salida%, "object{triangle{" + v1$ + "," + v2$ + "," + v3$ + "}}"

END SUB

FUNCTION esar% (na%)
escogearea:
CLS
COLOR 15, 0: LOCATE 3, 3: PRINT "ESCOJA EL AREA A CONVERTIR:"
COLOR 15, 0: LOCATE 4, 3: PRINT "==========================="
COLOR 8, 0: LOCATE 12, 1
PRINT "   Teclee el nmero del rea que desea convertir."
PRINT "   Los valores vlidos son de 1 a"; na%; "."
PRINT "   Si desea salir, pulse Ctrl-C."
COLOR 7, 0: LOCATE 7, 3
INPUT "Area"; ae$
ae% = VAL(ae$)
IF ae% < 1 OR ae% > na% OR ae% <> INT(ae%) THEN GOTO escogearea:
esar% = ae%
END FUNCTION

FUNCTION esen% (nde%)
escogeentrada:
CLS
COLOR 15, 0: LOCATE 3, 3: PRINT "ESCOJA LA ENTRADA QUE SERA LA CAMARA"
COLOR 15, 0: LOCATE 4, 3: PRINT "===================================="
COLOR 8, 0: LOCATE 12, 1
PRINT "   Teclee el nmero de la entrada que ser usada como"
PRINT "cmara. El programa convertir sus coordenadas y ngulo"
PRINT "en la posicin de la cmara para el fichero de POV-Ray."
PRINT "   Los valores vlidos son de 1 a"; nde%; "."
PRINT "   Si desea salir, pulse Ctrl-C."
COLOR 7, 0: LOCATE 7, 3
INPUT "Entrada"; ee$
ee% = VAL(ee$)
IF ee% < 1 OR ee% > nde% OR ee% <> INT(ee%) THEN GOTO escogeentrada:
esen% = ee%
END FUNCTION

FUNCTION esfi$
escogearchivo:
CLS
COLOR 15, 0: LOCATE 3, 3: PRINT "ESCOJA EL ARCHIVO DE ENTRADA:"
COLOR 15, 0: LOCATE 4, 3: PRINT "============================="
COLOR 8, 0: LOCATE 12, 1
PRINT "   Teclee el nombre del archivo de 3D-Construction Kit que desea"
PRINT "transformar en un archivo POV-Ray. Puede incluir la unidad y la"
PRINT "ruta de bsqueda (el directorio). Es obligatorio escribir la"
PRINT "extensin."
PRINT "   El archivo de salida tendr el mismo nombre, pero su extensin"
PRINT "ser .POV."
PRINT "   Si desea salir, pulse Ctrl-C."
COLOR 7, 0: LOCATE 7, 3
INPUT "Archivo"; ae$
IF LEN(ae$) < 4 THEN GOTO escogearchivo:
IF bm%(ae$, ".") = 0 THEN GOTO escogearchivo:
esfi$ = ae$
END FUNCTION

SUB fc (salida%)

' Procedimiento FormaCuadriltero (cc)
' Qu hace?:
'           elaborar un grupo de dos tringulos
'           que definan un cuadriltero.
' Entrada:
'           el array vc(de 1 hasta 4)
'           la variable salida%
' Salida:
'           en el fichero #salida%

' NOTA: Aunque este procedimiento parece ser doble, puesto que hay otro
'       llamado cc que es similar, no debe ser interpretado as. Este
'       tiene la funcin especfica de formar un cuadriltero que se
'       incluya dentro de otro objeto. En cambio, el procedimiento cc
'       construye un cuadriltero cuando el objeto general a describir
'       sea precisamente ese.

v1$ = vector$(vc(1, 1), vc(1, 2), vc(1, 3))
v2$ = vector$(vc(2, 1), vc(2, 2), vc(2, 3))
v3$ = vector$(vc(3, 1), vc(3, 2), vc(3, 3))
PRINT #salida%, "  triangle{" + v1$ + "," + v2$ + "," + v3$ + "}"
v1$ = vector$(vc(1, 1), vc(1, 2), vc(1, 3))
v2$ = vector$(vc(4, 1), vc(4, 2), vc(4, 3))
v3$ = vector$(vc(3, 1), vc(3, 2), vc(3, 3))
PRINT #salida%, "  triangle{" + v1$ + "," + v2$ + "," + v3$ + "}"

END SUB

FUNCTION lee$ (canal%)
' Funcin para leer una lnea en el archivo de 3DKIT
LINE INPUT #canal%, a$
lee$ = LTRIM$(RTRIM$(a$))

END FUNCTION

FUNCTION vector$ (v1%, v2%, v3%)

' Funcin Vector
' Qu hace?:
'           elaborar una cadena con un vector
' Entrada:
'           el array vc()
'           la variable p%
' Salida:
'           la cadena vector$

vector$ = "<" + STR$(v1%) + "," + STR$(v2%) + "," + STR$(v3%) + ">"

END FUNCTION

